#include "typedef.h"

#include <stdio.h>
#include <string.h>

#include "object.h"
#include "util.h"
#include "variable.h"

Cvariable	*Cvariable::g_hash[HASHSIZE] = {0};

/* static */ u4T
Cvariable::hash(Centity *entityP, const u2T *nameP)
{
	int		ret  = (int) entityP;
	u2T		c;
	const	u2T *P;

	for (P = nameP; c = *P ; ++P) {
		ret  += c;
		ret <<= 1;
		if (ret & HASHSIZE) {
			ret |= 1;
	}	}
	return(ret & (HASHSIZE-1));
}

Cvariable::Cvariable(Centity *parentP, const u2T *nameP, const u2T *descriptorP)
{
	m_hashP          = 0;
	m_parentP        = parentP;
	m_nameP          = unicodedup(nameP);
	m_descriptorP    = unicodedup(descriptorP);
	m_access_flags   = 0;
	add_created();
}

Cvariable *
Cvariable::locate(Centity *parentP, const u2T *nameP, const u2T *descriptorP)
{
	unsigned int	index;
	Cvariable		**variablePP, *variableP;

	index         = hash(parentP, nameP);
	for (variablePP = g_hash + index; variableP = *variablePP; variablePP = &(variableP->m_hashP)) {
		if (variableP->m_parentP != parentP) {
			continue;
		}
		if (unicodecmp(variableP->m_nameP, nameP)) {
			continue;
		}
		return(variableP);
	}	
	variableP = new Cvariable(parentP, nameP, descriptorP);
	if (!variableP) {
		outofmemory();
	}
	variableP->add_created();
	*variablePP = variableP;
	return(variableP);
}

/* virtual */ objectE
Cvariable::type(void) const
{
	return(variableE);
}

/* virtual */ void
Cvariable::emit_id(void) const
{
	fprintf(stdout, "L%p", this);
}

const char *
Cvariable::get_type(void) const
{
	return("L");
}
		
/* virtual */ void
Cvariable::emit_instance(void) const
{
	fprintf(stdout, "$INSTANCE L%p L\n", this);
}

void
Cvariable::emit_attributes(void) const
{
	emit_id();
	fputs(" {label=\"", stdout);
	dumpUnicode(m_nameP);
	fputc('"', stdout);

	fputs(" file=.", stdout);

	if (m_descriptorP) {
		fputs(" descriptor=\"", stdout);
		dump_descriptor(m_descriptorP);
		fputc('"', stdout);
	}

	if (m_access_flags) {
		fputs(" access=\"", stdout);
		dump_access(m_access_flags);
		fputc('"', stdout);
	}
	fputs("}\n", stdout);
}

